//
// Avi2Flc v0.2 D (28/08/19) by ssjx (http://ssjx.co.uk)
//
// FLI Structs / Functions
//
//import std.stdio;
module fli;

@safe:

struct Myflihdr 
{
	align(1):
    int size;
    short magic;
    short frames;
    short width;
    short height;
    short depth;
    short flags;
    short speed;
    int next;
    int frit;
    ubyte[102] expand;
}

struct Myfrmhdr 
{
  	align(1):
    int size;
    short magic;
    short chunks;
    ubyte[8] expand;
}

struct Mychkhdr 
{
  	align(1):
	int size;
	short typ;
}

struct Mypal
{
  	align(1):
	short packets;
	ubyte skip;
	ubyte change;
}

struct Myrgb 
{
  	align(1):
	ubyte r;
	ubyte g;
	ubyte b;
}

//
//
//

void encode_copy(const ubyte[] pix, ubyte[] outdata)
{
	foreach(i;0..pix.length){
		outdata[i]=pix[i];
	}
}

// 15 : RLE Frame
int encode_rle(const ubyte[] pix, ubyte[] outdata,const int width, const int height)
{
	int outpos;
	int inpos;
	int packet_pos;
	ubyte pb;
	ubyte cnt;
	int packets;
	
	foreach(j;0..height)
	{
		packets=0;
		// Marking the space where packet count will go...
		packet_pos=outpos;
		outpos++;
		
		pb=pix[inpos++];
		cnt=1;
		
		foreach(i;1..width)
		{
			if ((pix[inpos]==pb) && (cnt<126))
			{
				cnt++;
			}
			else
			{
				outdata[outpos++]=cnt;
				outdata[outpos++]=pb;
				packets++;
			
				pb=pix[inpos];
				cnt=1;
			}
			// Compression not worth it and risk of going beyond outdata[] range so giving up...
			if (outpos>(width*height)-100){return -1;}
			
			inpos++;
		}

		outdata[outpos++]=cnt;
		outdata[outpos++]=pb;
		packets++;
	
		// Correct packet count!
		if (packets>255){packets=0;}
		outdata[packet_pos]=cast(ubyte)packets;
	}

	return outpos;
}






