//
// Avi2Flc v0.3 D (28/08/19) by ssjx (http://ssjx.co.uk)
//
// Decode 'msvc' (Microsoft Video 1) frames
//
module msvc;

@safe:

/* 16bit to 24bit to 8bit (gray)  */
private ubyte gbyte(const ushort col){
	int r=((col & 0x7c00)>>10);
	int g=((col & 0x03e0)>>5);
	int b=(col & 0x001f);
	
	r=r>>2;
	g=g>>2;
	b=b>>3;
			
	int ar=r<<5;
	int ag=g<<2;
	int ab=b;
			
	int outcol=ar+ag+ab;
	
	return cast(ubyte)(outcol);
}

//  cram8c#
private void cram8c1(ubyte[] ip,int off,ubyte clr,int rdec)
{
	foreach(j;0..4){
	  	ip[off+0]=clr;
	  	ip[off+1]=clr;
	  	ip[off+2]=clr;
	  	ip[off+3]=clr;
	  	off+=rdec;
	}
}

private void cram8c2(ubyte[] ip,int off,ubyte flag,ushort cA,ushort cB,int rdec)
{
	immutable ubyte realcb=gbyte(cB);
	immutable ubyte realca=gbyte(cA);

	ip[off+0]=(flag & 0x01) ? (realcb) : (realca);
	ip[off+1]=(flag & 0x02) ? (realcb) : (realca);
	ip[off+2]=(flag & 0x04) ? (realcb) : (realca);
	ip[off+3]=(flag & 0x08) ? (realcb) : (realca);
	off=off-rdec;
	ip[off+0]=(flag & 0x10) ? (realcb) : (realca);
	ip[off+1]=(flag & 0x20) ? (realcb) : (realca);
	ip[off+2]=(flag & 0x40) ? (realcb) : (realca);
	ip[off+3]=(flag & 0x80) ? (realcb) : (realca);
}

private void cram8c4(ubyte[] ip,int off, ubyte flag, ushort cA0,ushort cA1, ushort cB0,ushort cB1,int rowDec)
{
	immutable ubyte a0=gbyte(cA0);
	immutable ubyte a1=gbyte(cA1);
	immutable ubyte b0=gbyte(cB0);
	immutable ubyte b1=gbyte(cB1);

	ip[off+0]=(flag & 0x01) ? (b0) : (a0);
	ip[off+1]=(flag & 0x02) ? (b0) : (a0);
	ip[off+2]=(flag & 0x04) ? (b1) : (a1);
	ip[off+3]=(flag & 0x08) ? (b1) : (a1);
	off=off-rowDec;
	ip[off+0]=(flag & 0x10) ? (b0) : (a0);
	ip[off+1]=(flag & 0x20) ? (b0) : (a0);
	ip[off+2]=(flag & 0x40) ? (b1) : (a1);
	ip[off+3]=(flag & 0x80) ? (b1) : (a1);
}


void decode_msvc(ubyte[] from,ubyte[] to,int width, int height)
{
	int encSize=from.length;
	
	int skip,pos,offset;
	ushort ca,cb,cc,cd,caz;
	ubyte clr;
	ubyte code0,code1;
	int xp;
	int yp=height-1;

	while(true)
	{
		code0=from[0+pos];
		code1=from[1+pos];
		pos+=2;

		if ((code1>=0x84) && (code1<=0x87))
		{
			skip=((code1-0x84)<<8)+code0;

			while(skip>0)
			{
				skip--;
				xp+=4;
				if(xp>=width){yp-=4;xp=0;}
			}
		}
		else
		{
			if (code1<0x80)
			{
				ca=cast(ushort)((from[pos+1]<<8)+from[pos+0]);
				cb=cast(ushort)((from[pos+3]<<8)+from[pos+2]);

				if (ca & 0x8000)
				{
					cc=cast(ushort)((from[pos+5]<<8)+from[pos+4]);
					cd=cast(ushort)((from[pos+7]<<8)+from[pos+6]);

					offset=(yp*width)+xp;
					cram8c4(to,offset,code0,cb,cd,ca,cc,width);

					ca=cast(ushort)((from[pos+9]<<8)+from[pos+8]);
					cb=cast(ushort)((from[pos+11]<<8)+from[pos+10]);

					cc=cast(ushort)((from[pos+13]<<8)+from[pos+12]);
					cd=cast(ushort)((from[pos+15]<<8)+from[pos+14]);

					offset=((yp-2)*width)+xp;
					cram8c4(to,offset,code1,cb,cd,ca,cc,width);

					pos+=12;
				}
				else
				{
					offset=(yp*width)+xp;
					cram8c2(to,offset,code0,cb,ca,width);

					offset=((yp-2)*width)+xp;
					cram8c2(to,offset,code1,cb,ca,width);
				}					
				pos+=4;
			}
			else
			{
				caz=cast(ushort)((code1<<8)+code0);
				clr=gbyte(caz);
				
				offset=((yp-3)*width)+xp;
				cram8c1(to,offset,clr,width);
			}
			
			xp+=4;
			if(xp>=width){yp-=4;xp=0;}
		}
		
		if (pos>=encSize || yp<0) { break;}
	}
}
/* \\\ */

